GNU bug report logs - #23594
25.0.94; Display errors on Linux tty

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Alan Mackenzie <acm@HIDDEN>; Keywords: fixed pending; dated Sat, 21 May 2016 10:55:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Added tag(s) fixed and pending. Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 21:12:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 17:12:52 2016
Received: from localhost ([127.0.0.1]:33090 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4ag7-0001T4-RA
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 17:12:52 -0400
Received: from mail.muc.de ([193.149.48.3]:52327)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4ag1-0001Sr-L6
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 17:12:50 -0400
Received: (qmail 52905 invoked by uid 3782); 22 May 2016 21:12:44 -0000
Received: from acm.muc.de (p4FC467AB.dip0.t-ipconnect.de [79.196.103.171]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sun, 22 May 2016 23:12:42 +0200
Received: (qmail 14853 invoked by uid 1000); 22 May 2016 21:12:46 -0000
Date: Sun, 22 May 2016 21:12:46 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160522211246.GG2136@HIDDEN>
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
 <20160522093813.GA2136@HIDDEN> <838tz26rkh.fsf@HIDDEN>
 <20160522161651.GE2136@HIDDEN> <83y4725967.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83y4725967.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello again, Eli.

On Sun, May 22, 2016 at 07:50:24PM +0300, Eli Zaretskii wrote:

[ .... ]

> I think the best fix that is safe for Emacs 25.1 is simply to avoid
> displaying the "decomposition" part for low control characters -- they
> cannot be composed anyway, AFAIU.

I've committed a patch to emacs-25 which does exactly that.

Since it's a workaround rather than a fix, I think it would be better to
leave the bug open for now.

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 20:03:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 16:03:06 2016
Received: from localhost ([127.0.0.1]:33066 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4Zac-0008LJ-4M
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 16:03:06 -0400
Received: from mail.muc.de ([193.149.48.3]:27761)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4ZaZ-0008L9-VB
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 16:03:04 -0400
Received: (qmail 41641 invoked by uid 3782); 22 May 2016 20:03:02 -0000
Received: from acm.muc.de (p4FC467AB.dip0.t-ipconnect.de [79.196.103.171]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sun, 22 May 2016 22:03:01 +0200
Received: (qmail 6014 invoked by uid 1000); 22 May 2016 20:03:04 -0000
Date: Sun, 22 May 2016 20:03:04 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160522200304.GF2136@HIDDEN>
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
 <20160522093813.GA2136@HIDDEN> <838tz26rkh.fsf@HIDDEN>
 <20160522161651.GE2136@HIDDEN> <83y4725967.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83y4725967.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello, Eli.

On Sun, May 22, 2016 at 07:50:24PM +0300, Eli Zaretskii wrote:
> > Date: Sun, 22 May 2016 16:16:51 +0000
> > Cc: 23594 <at> debbugs.gnu.org
> > From: Alan Mackenzie <acm@HIDDEN>

> > could it be that the display engine is actually outputting a raw
> > 0x0a byte

> Of course!  Isn't that what I said at the beginning of this
> discussion?

Yes it was, but that was rather a long time ago.  ;-)  I've been poring
over code since then, which left me somewhat confused.  It's difficult
stuff.

> > rather than handling it sensibly?

> It was forbidden from doing "sensible" things by the composition
> trick.

OK.

> I think the best fix that is safe for Emacs 25.1 is simply to avoid
> displaying the "decomposition" part for low control characters -- they
> cannot be composed anyway, AFAIU.

OK, I'll come with a patch to do that.

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 16:50:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 12:50:40 2016
Received: from localhost ([127.0.0.1]:32987 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4WaO-0002A6-0c
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 12:50:40 -0400
Received: from eggs.gnu.org ([208.118.235.92]:40411)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1b4WaM-00029s-18
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 12:50:38 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1b4WaD-0003QS-ES
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 12:50:32 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.6 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:51426)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1b4WaC-0003QL-Tm; Sun, 22 May 2016 12:50:29 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2362
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1b4WaB-00024B-6K; Sun, 22 May 2016 12:50:27 -0400
Date: Sun, 22 May 2016 19:50:24 +0300
Message-Id: <83y4725967.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
In-reply-to: <20160522161651.GE2136@HIDDEN> (message from Alan
 Mackenzie on Sun, 22 May 2016 16:16:51 +0000)
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
 <20160522093813.GA2136@HIDDEN> <838tz26rkh.fsf@HIDDEN>
 <20160522161651.GE2136@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> Date: Sun, 22 May 2016 16:16:51 +0000
> Cc: 23594 <at> debbugs.gnu.org
> From: Alan Mackenzie <acm@HIDDEN>
> 
> could it be that the display engine is actually outputting a raw
> 0x0a byte

Of course!  Isn't that what I said at the beginning of this
discussion?

> rather than handling it sensibly?

It was forbidden from doing "sensible" things by the composition
trick.

I think the best fix that is safe for Emacs 25.1 is simply to avoid
displaying the "decomposition" part for low control characters -- they
cannot be composed anyway, AFAIU.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 16:16:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 12:16:50 2016
Received: from localhost ([127.0.0.1]:32958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4W3e-0006SE-LU
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 12:16:50 -0400
Received: from mail.muc.de ([193.149.48.3]:20690)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4W3d-0006S5-FV
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 12:16:50 -0400
Received: (qmail 95782 invoked by uid 3782); 22 May 2016 16:16:48 -0000
Received: from acm.muc.de (p4FC467AB.dip0.t-ipconnect.de [79.196.103.171]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sun, 22 May 2016 18:16:46 +0200
Received: (qmail 4585 invoked by uid 1000); 22 May 2016 16:16:51 -0000
Date: Sun, 22 May 2016 16:16:51 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160522161651.GE2136@HIDDEN>
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
 <20160522093813.GA2136@HIDDEN> <838tz26rkh.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <838tz26rkh.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello, Eli.

On Sun, May 22, 2016 at 06:27:42PM +0300, Eli Zaretskii wrote:
> > On Sat, May 21, 2016 at 10:09:38PM +0300, Eli Zaretskii wrote:
> > > > > This bug exists since we started showing the 'decomposition' of
> > > > > characters in Emacs 24.1.  With LF, we send a literal LF character
> > > > > to the screen.

> > That's only half the story.  The literal LF doesn't seem to be the
> > problem.

> What do you mean by "literal LF"?  A newline ends a line, and is never
> displayed at all, the display engine "swallows" it so it disappears
> without a trace, and instead instructs the terminal to move to the
> next line.

I mean (insert "\n") works without problems, even though it's more like a
command, and isn't a glyph.

> > Rather, it's got a 'composition text-property attached to it.
> > The string we're trying to display is

> > #("  decomposition: (10) ('\n')\n" 24 25 (composition (0 1 [9 10 9])))
> >                            ^
> > 			       |
> > 			       24

> > What is this composition trying to do?  The [9 10 9] is [\t \n \t].

> It tries to prevent the character from being composed with surrounding
> ones, so that we could display there combining marks and other similar
> stuff.

OK.

> > Under X-Windows, the same string is displayed, this time successfully.
> > The call
> >     (inseert #("  decomposition: .... [9 10 9])))
> > works on X-Windows, the "\n" with the composition property being
> > displayed as a square box.

> Why is that a "success", exactly?  Is the user supposed to guess that
> the box represents a LF?

It's a "success" in contrast to the failure on a Linux virtual terminal,
where text in the other window ends up displayed where it isn't situated.

> > > > OK.  The next question is is it easy to fix?

> > > Yes.  We should not send control characters to that buffer.

> > It seems to me there is a bug in the display engine here: the same
> > string which is displayed successfully in X-Windows goes badly wrong on
> > a Linux tty.

> > Comments?

> IMO, there's no such thing as a successful display of an unadorned LF
> (or any other control character), on any kind of terminal.  What would
> be the graphics for that?

I suppose one answer would be that glyph with a tiny "L" in the top left
corner and a tiny "F" in the bottom right corner.  But we couldn't use
that, since we don't know that the current terminal can display it.
Another answer would be some standard substitute character (like an
inverse question mark, or whatever).

But the real point seems to me to be that `insert'ing the above string
(with the composition property) completely fouls up the display in the
other window.  I'm guessing here, but could it be that the display engine
is actually outputting a raw 0x0a byte rather than handling it sensibly?

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 15:27:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 11:27:57 2016
Received: from localhost ([127.0.0.1]:32950 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4VIL-0005KX-Ml
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 11:27:57 -0400
Received: from eggs.gnu.org ([208.118.235.92]:50857)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1b4VIL-0005KJ-1h
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 11:27:57 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1b4VIB-0000wk-MV
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 11:27:51 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.6 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:49768)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1b4VIB-0000vb-JS; Sun, 22 May 2016 11:27:47 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2226
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1b4VI9-0001Nf-KE; Sun, 22 May 2016 11:27:46 -0400
Date: Sun, 22 May 2016 18:27:42 +0300
Message-Id: <838tz26rkh.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
In-reply-to: <20160522093813.GA2136@HIDDEN> (message from Alan
 Mackenzie on Sun, 22 May 2016 09:38:13 +0000)
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
 <20160522093813.GA2136@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> Date: Sun, 22 May 2016 09:38:13 +0000
> Cc: 23594 <at> debbugs.gnu.org
> From: Alan Mackenzie <acm@HIDDEN>
> 
> On Sat, May 21, 2016 at 10:09:38PM +0300, Eli Zaretskii wrote:
> > > > This bug exists since we started showing the 'decomposition' of
> > > > characters in Emacs 24.1.  With LF, we send a literal LF character
> > > > to the screen.
> 
> That's only half the story.  The literal LF doesn't seem to be the
> problem.

What do you mean by "literal LF"?  A newline ends a line, and is never
displayed at all, the display engine "swallows" it so it disappears
without a trace, and instead instructs the terminal to move to the
next line.

> Rather, it's got a 'composition text-property attached to it.
> The string we're trying to display is
> 
> #("  decomposition: (10) ('\n')\n" 24 25 (composition (0 1 [9 10 9])))
>                            ^
> 			   |
> 			   24
> 
> What is this composition trying to do?  The [9 10 9] is [\t \n \t].

It tries to prevent the character from being composed with surrounding
ones, so that we could display there combining marks and other similar
stuff.

> Under X-Windows, the same string is displayed, this time successfully.
> The call
>     (inseert #("  decomposition: .... [9 10 9])))
> works on X-Windows, the "\n" with the composition property being
> displayed as a square box.

Why is that a "success", exactly?  Is the user supposed to guess that
the box represents a LF?

> > > OK.  The next question is is it easy to fix?
> 
> > Yes.  We should not send control characters to that buffer.
> 
> It seems to me there is a bug in the display engine here: the same
> string which is displayed successfully in X-Windows goes badly wrong on
> a Linux tty.
> 
> Comments?

IMO, there's no such thing as a successful display of an unadorned LF
(or any other control character), on any kind of terminal.  What would
be the graphics for that?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 22 May 2016 09:38:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 22 05:38:15 2016
Received: from localhost ([127.0.0.1]:60374 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4Ppu-0003v6-Pp
	for submit <at> debbugs.gnu.org; Sun, 22 May 2016 05:38:14 -0400
Received: from mail.muc.de ([193.149.48.3]:62743)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4Ppt-0003uw-EL
 for 23594 <at> debbugs.gnu.org; Sun, 22 May 2016 05:38:13 -0400
Received: (qmail 20444 invoked by uid 3782); 22 May 2016 09:38:11 -0000
Received: from acm.muc.de (p4FC467AB.dip0.t-ipconnect.de [79.196.103.171]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sun, 22 May 2016 11:38:09 +0200
Received: (qmail 2938 invoked by uid 1000); 22 May 2016 09:38:13 -0000
Date: Sun, 22 May 2016 09:38:13 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160522093813.GA2136@HIDDEN>
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83d1of6xe5.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello, Eli.

On Sat, May 21, 2016 at 10:09:38PM +0300, Eli Zaretskii wrote:
> > > This bug exists since we started showing the 'decomposition' of
> > > characters in Emacs 24.1.  With LF, we send a literal LF character
> > > to the screen.

That's only half the story.  The literal LF doesn't seem to be the
problem.  Rather, it's got a 'composition text-property attached to it.
The string we're trying to display is

#("  decomposition: (10) ('\n')\n" 24 25 (composition (0 1 [9 10 9])))
                           ^
			   |
			   24

What is this composition trying to do?  The [9 10 9] is [\t \n \t].

The whole thing is a result of calling
    (char-code-property-description 'decomposition '(10))

Under X-Windows, the same string is displayed, this time successfully.
The call
    (inseert #("  decomposition: .... [9 10 9])))
works on X-Windows, the "\n" with the composition property being
displayed as a square box.

> > OK.  The next question is is it easy to fix?

> Yes.  We should not send control characters to that buffer.

It seems to me there is a bug in the display engine here: the same
string which is displayed successfully in X-Windows goes badly wrong on
a Linux tty.

Comments?

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 21 May 2016 20:35:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 16:35:17 2016
Received: from localhost ([127.0.0.1]:60197 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4DcC-0007EE-S3
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 16:35:17 -0400
Received: from mail.muc.de ([193.149.48.3]:47638)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4DcA-0007E4-Sc
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 16:35:15 -0400
Received: (qmail 93157 invoked by uid 3782); 21 May 2016 20:35:12 -0000
Received: from acm.muc.de (p548C6006.dip0.t-ipconnect.de [84.140.96.6]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sat, 21 May 2016 22:35:11 +0200
Received: (qmail 13714 invoked by uid 1000); 21 May 2016 20:35:16 -0000
Date: Sat, 21 May 2016 20:35:16 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160521203516.GC2987@HIDDEN>
References: <20160521104720.GA2987@HIDDEN> <83k2in72de.fsf@HIDDEN>
 <20160521190110.GB2987@HIDDEN> <83d1of6xe5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83d1of6xe5.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello, Eli.

On Sat, May 21, 2016 at 10:09:38PM +0300, Eli Zaretskii wrote:
> > Date: Sat, 21 May 2016 19:01:10 +0000
> > Cc: 23594 <at> debbugs.gnu.org
> > From: Alan Mackenzie <acm@HIDDEN>

> > > This bug exists since we started showing the 'decomposition' of
> > > characters in Emacs 24.1.  With LF, we send a literal LF character to
> > > the screen.

> > OK.  The next question is is it easy to fix?

> Yes.  We should not send control characters to that buffer.

OK, I'm looking at it.

Is there any chance of getting a patch for this into Emacs 25.1?  I know
this is nothing new, but it's very ugly.

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 21 May 2016 19:09:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 15:09:48 2016
Received: from localhost ([127.0.0.1]:60174 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4CHU-0005Fl-HD
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 15:09:48 -0400
Received: from eggs.gnu.org ([208.118.235.92]:42114)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1b4CHS-0005FZ-Vt
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 15:09:47 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1b4CHJ-0003qz-93
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 15:09:41 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-3.3 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:39530)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1b4CHJ-0003qv-60; Sat, 21 May 2016 15:09:37 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:1333
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1b4CHG-0000Ke-1F; Sat, 21 May 2016 15:09:35 -0400
Date: Sat, 21 May 2016 22:09:38 +0300
Message-Id: <83d1of6xe5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
In-reply-to: <20160521190110.GB2987@HIDDEN> (message from Alan
 Mackenzie on Sat, 21 May 2016 19:01:10 +0000)
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
References: <20160521104720.GA2987@HIDDEN>
 <83k2in72de.fsf@HIDDEN> <20160521190110.GB2987@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> Date: Sat, 21 May 2016 19:01:10 +0000
> Cc: 23594 <at> debbugs.gnu.org
> From: Alan Mackenzie <acm@HIDDEN>
> 
> > This bug exists since we started showing the 'decomposition' of
> > characters in Emacs 24.1.  With LF, we send a literal LF character to
> > the screen.
> 
> OK.  The next question is is it easy to fix?

Yes.  We should not send control characters to that buffer.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 21 May 2016 19:01:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 15:01:11 2016
Received: from localhost ([127.0.0.1]:60163 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4C99-00053c-Al
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 15:01:11 -0400
Received: from mail.muc.de ([193.149.48.3]:61582)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b4C96-00053S-MK
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 15:01:09 -0400
Received: (qmail 76376 invoked by uid 3782); 21 May 2016 19:01:06 -0000
Received: from acm.muc.de (p548C6006.dip0.t-ipconnect.de [84.140.96.6]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sat, 21 May 2016 21:01:05 +0200
Received: (qmail 13414 invoked by uid 1000); 21 May 2016 19:01:10 -0000
Date: Sat, 21 May 2016 19:01:10 +0000
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
Message-ID: <20160521190110.GB2987@HIDDEN>
References: <20160521104720.GA2987@HIDDEN>
 <83k2in72de.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <83k2in72de.fsf@HIDDEN>
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hello, Eli.

On Sat, May 21, 2016 at 08:22:05PM +0300, Eli Zaretskii wrote:
> > Date: Sat, 21 May 2016 10:47:20 +0000
> > From: Alan Mackenzie <acm@HIDDEN>

> > emacs -Q
> > C-x b foo.c
> > M-x c-mode

> > Type the following five lines into the buffer:
> > #########################################################################
> > char foo [] = "foo";

> > #define FOO BAR

> > char bar [] = "bar";
> > #########################################################################

> > Move point to just after "BAR" on line 3.
> > C-u C-x =

> > There are now two display bugs evident:
> > 1. The vertical divider between the two windows is missing a piece just
> > after the line "  decomposition: (10) ('" in *Help*.

> > 2. In foo.c, the actual text display is out of sync with the text cursor.
> > The text has been scrolled one line up, but the cursor has remained at
> > the same position in the window, apparently at the end of a non-existent
> > line of spaces.  The cursor can be freely moved, but is one line out of
> > sync with the displayed text.

> I see this, but I don't understand why you needed the c-mode stuff and
> the text.  the same problem happens in a buffer in Fundamental mode
> when you invoke "C-u C-x =" at a newline.

Hmm.  Maybe I wanted to take some of the blame.  ;-)

> This bug exists since we started showing the 'decomposition' of
> characters in Emacs 24.1.  With LF, we send a literal LF character to
> the screen.

OK.  The next question is is it easy to fix?

-- 
Alan Mackenzie (Nuremberg, Germany).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at 23594 <at> debbugs.gnu.org:


Received: (at 23594) by debbugs.gnu.org; 21 May 2016 17:22:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 13:22:05 2016
Received: from localhost ([127.0.0.1]:60118 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b4AbF-0007pN-EB
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 13:22:05 -0400
Received: from eggs.gnu.org ([208.118.235.92]:51247)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1b4AbE-0007os-0o
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 13:22:04 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1b4Ab5-0000eO-Kk
 for 23594 <at> debbugs.gnu.org; Sat, 21 May 2016 13:21:58 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.4 required=5.0 tests=BAYES_20,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:38579)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1b4Ab5-0000eK-He; Sat, 21 May 2016 13:21:55 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:1193
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1b4Ab3-0004rd-K0; Sat, 21 May 2016 13:21:54 -0400
Date: Sat, 21 May 2016 20:22:05 +0300
Message-Id: <83k2in72de.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Alan Mackenzie <acm@HIDDEN>
In-reply-to: <20160521104720.GA2987@HIDDEN> (message from Alan
 Mackenzie on Sat, 21 May 2016 10:47:20 +0000)
Subject: Re: bug#23594: 25.0.94; Display errors on Linux tty
References: <20160521104720.GA2987@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 23594
Cc: 23594 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

> Date: Sat, 21 May 2016 10:47:20 +0000
> From: Alan Mackenzie <acm@HIDDEN>
> 
> emacs -Q
> C-x b foo.c
> M-x c-mode
> 
> Type the following five lines into the buffer:
> #########################################################################
> char foo [] = "foo";
> 
> #define FOO BAR
> 
> char bar [] = "bar";
> #########################################################################
> 
> Move point to just after "BAR" on line 3.
> C-u C-x =
> 
> There are now two display bugs evident:
> 1. The vertical divider between the two windows is missing a piece just
> after the line "  decomposition: (10) ('" in *Help*.
> 
> 2. In foo.c, the actual text display is out of sync with the text cursor.
> The text has been scrolled one line up, but the cursor has remained at
> the same position in the window, apparently at the end of a non-existent
> line of spaces.  The cursor can be freely moved, but is one line out of
> sync with the displayed text.

I see this, but I don't understand why you needed the c-mode stuff and
the text.  the same problem happens in a buffer in Fundamental mode
when you invoke "C-u C-x =" at a newline.

This bug exists since we started showing the 'decomposition' of
characters in Emacs 24.1.  With LF, we send a literal LF character to
the screen.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 May 2016 10:54:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 21 06:54:14 2016
Received: from localhost ([127.0.0.1]:59553 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1b44Xu-0005av-9u
	for submit <at> debbugs.gnu.org; Sat, 21 May 2016 06:54:14 -0400
Received: from eggs.gnu.org ([208.118.235.92]:46894)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <acm@HIDDEN>) id 1b44Xs-0005aj-GK
 for submit <at> debbugs.gnu.org; Sat, 21 May 2016 06:54:12 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <acm@HIDDEN>) id 1b44Xm-0004hD-9T
 for submit <at> debbugs.gnu.org; Sat, 21 May 2016 06:54:07 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:45421)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <acm@HIDDEN>)
 id 1b44Xm-0004h3-6M
 for submit <at> debbugs.gnu.org; Sat, 21 May 2016 06:54:06 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:37857)
 by lists.gnu.org with esmtp (Exim 4.71) (envelope-from <acm@HIDDEN>)
 id 1b44Xj-00064c-Sp
 for bug-gnu-emacs@HIDDEN; Sat, 21 May 2016 06:54:04 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <acm@HIDDEN>) id 1b44Xf-0004gY-Sa
 for bug-gnu-emacs@HIDDEN; Sat, 21 May 2016 06:54:03 -0400
Received: from mail.muc.de ([193.149.48.3]:10897)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <acm@HIDDEN>)
 id 1b44Xf-0004gU-Ip
 for bug-gnu-emacs@HIDDEN; Sat, 21 May 2016 06:53:59 -0400
Received: (qmail 97407 invoked by uid 3782); 21 May 2016 10:47:17 -0000
Received: from acm.muc.de (p548C6006.dip0.t-ipconnect.de [84.140.96.6]) by
 colin.muc.de (tmda-ofmipd) with ESMTP;
 Sat, 21 May 2016 12:47:16 +0200
Received: (qmail 3092 invoked by uid 1000); 21 May 2016 10:47:20 -0000
Date: Sat, 21 May 2016 10:47:20 +0000
To: bug-gnu-emacs@HIDDEN
Subject: 25.0.94; Display errors on Linux tty
Message-ID: <20160521104720.GA2987@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.5.24 (2015-08-30)
X-Delivery-Agent: TMDA/1.1.12 (Macallan)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-detected-operating-system: by eggs.gnu.org: FreeBSD 9.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.3 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.3 (----)

In GNU Emacs 25.0.94.1 (x86_64-unknown-linux-gnu, GTK+ Version 3.18.7)
 of 2016-05-17 built on acm
Configured using:
 'configure --with-tiff=no --with-gif=no --with-gpm'

Configured features:
XPM JPEG PNG RSVG SOUND GPM DBUS GSETTINGS NOTIFY ACL GNUTLS LIBXML2
FREETYPE XFT ZLIB TOOLKIT_SCROLL_BARS GTK3 X11

Important settings:
  value of $LANG: en_GB.utf8
  locale-coding-system: utf-8-unix

Major mode: C/l

Minor modes in effect:
  gpm-mouse-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t
  abbrev-mode: t

(This is the latest pretest version.)

emacs -Q
C-x b foo.c
M-x c-mode

Type the following five lines into the buffer:
#########################################################################
char foo [] = "foo";

#define FOO BAR

char bar [] = "bar";
#########################################################################

Move point to just after "BAR" on line 3.
C-u C-x =

There are now two display bugs evident:
1. The vertical divider between the two windows is missing a piece just
after the line "  decomposition: (10) ('" in *Help*.

2. In foo.c, the actual text display is out of sync with the text cursor.
The text has been scrolled one line up, but the cursor has remained at
the same position in the window, apparently at the end of a non-existent
line of spaces.  The cursor can be freely moved, but is one line out of
sync with the displayed text.

Type C-l one or more times.  The foo.c window becomes increasingly
confused.  Type <backspace>.  This causes even more confusion.

The bugs are not evident in X-Windows.

-- 
Alan Mackenzie (Nuremberg, Germany).




Acknowledgement sent to Alan Mackenzie <acm@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#23594; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 17 Jun 2016 04:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.